	SUBROUTINE CENTR1(LU_IN,DAT,NCOL,NROW,ARRAY,MAPN,LLO,MLO,THETA,X,Y,
	1FWHMA,FWHMB,ITOT,PEAK,SKY)
C
C       This subroutine helps CENTR by allowing operation of the
C  subroutine DYNAMIC.  Calls are made to other subroutines to determine
C  the centroid and FWHM.
C			Donald H. Gudehus, January, 1983
C			Version 2, Donald H. Gudehus, March, 1989
C			Added code for IHED
C			Version 2U, Donald H. Gudehus, Feb. 1, 2008
C			Converted to Unix and FITS (no IHED)
C
	DIMENSION DAT(NCOL,NROW),ARRAY(1)
	REAL*8 AVG,SIG
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
	CALL RDFITSXY(LU_IN,IMNUM,IPNUM,DAT,NCOL,NROW,LLO,NCOL,MLO,NROW)
	CALL AVERSIG(DAT,NCOL,NROW,1,1,NCOL,NROW,.TRUE.,AVG,SIG)
	CALL MNMXME2D(DAT,NCOL,NROW,.TRUE.,SKY,PEAK,IMIN,IMAX,JMIN,JMAX,MEAN)
	CALL CENTROID(DAT,NCOL,NROW,NCOL,NROW,SNGL(AVG),X,Y,ITOT)
	CALL FWHM(DAT,NCOL,NROW,ARRAY,X,Y,THETA,FWHMA,FWHMB)
	X=X+FLOATJ(LLO)-1.0
	Y=Y+FLOATJ(MLO)-1.0
	RETURN
	END
