	SUBROUTINE SCAN(AM,NNN,MMM,M,N,CL,D,R,TH,HT,IZX,
	1IRC,IDIMEN1,X,IDIMEN2,Y,IDIMEN3)
C
C  This subroutine finds the start of a specified contour and
C  controls the tracing of it.
C
C		Version 2, Donald H. Gudehus, July 8, 1992
C		Made IRC, X, and Y passed length arrays
C
	DIMENSION AM(NNN,MMM),IRC(IDIMEN1),X(IDIMEN2),Y(IDIMEN3)
	DIMENSION IPT(3,3),INNX(8),INNY(8)
	LOGICAL DRAW
	COMMON /SCAN_BLOCK/ MT,NT,NI,IX,IY,IDX,IDY,ISS,IT,IV,NP,NQ,JT,
	1 PY,CV,IPT,INNX,INNY,DL,RA,THE,NTP,RAT,H
	NP=0
	H=HT
	DL=D
	RA=R
	THE=TH
	MT=M
	NT=N
	CV=CL
	IF (IZX.EQ.0) THEN
	  IZX=2
C  Set test directions
	  IPT(1,1)=8
	  IPT(1,2)=1
	  IPT(1,3)=2
	  IPT(2,1)=7
	  IPT(2,2)=0
	  IPT(2,3)=3
	  IPT(3,1)=6
	  IPT(3,2)=5
	  IPT(3,3)=4
C
	  INNX(1)=-1
	  INNX(2)=-1
	  INNX(3)=0
	  INNX(4)=1
	  INNX(5)=1
	  INNX(6)=1
	  INNX(7)=0
	  INNX(8)=-1
	  INNY(1)=0
	  INNY(2)=1
	  INNY(3)=1
	  INNY(4)=1
	  INNY(5)=0
	  INNY(6)=-1
	  INNY(7)=-1
	  INNY(8)=-1
	END IF
	DO J=1,800  ! ?
	  IRC(J)=0
	END DO
	ISS=0
C  Check left side of array for positive slope contour crossings
	MT1=MT-1
	DO I=1,MT1
	  IF (AM(I,1).LT.CV) THEN
	    IF (AM(I,1).NE.-999.0) THEN
              IF (AM(I+1,1).GE.CV) THEN
	        IX=I+1
	        IY=1
	        IDX=-1
	        IDY=0
	        CALL TRACE(AM,NNN,MMM,IRC,IDIMEN1,X,IDIMEN2,Y,IDIMEN3)
	      END IF
	    END IF
	  END IF
	END DO
C  Check bottom row of array for positive slope contour crossings
	NT1=NT-1
	DO I=1,NT1
	  IF (AM(MT,I).LT.CV) THEN
	    IF (AM(MT,I).NE.-999.0) THEN
	      IF (AM(MT,I+1).GE.CV) THEN
	        IX=MT
	        IY=I+1
	        IDX=0
	        IDY=-1
	        CALL TRACE(AM,NNN,MMM,IRC,IDIMEN1,X,IDIMEN2,Y,IDIMEN3)
	      END IF
	    END IF
	  END IF
	END DO
C  Check right side of array for positive slope contour crossings
	DO I=1,MT1
	  MT2=MT+1-I
	  IF (AM(MT2,NT).LT.CV) THEN
	    IF (AM(MT2,NT).NE.-999.0) THEN
	      IF (AM(MT2-1,NT).GE.CV) THEN
	        IX=MT2-1
	        IY=NT
	        IDX=1
	        IDY=0
	        CALL TRACE(AM,NNN,MMM,IRC,IDIMEN1,X,IDIMEN2,Y,IDIMEN3)
	      END IF
	    END IF
	  END IF
	END DO
C  Check top of array for positive slope contour crossings
	DO I=1,NT1
	  NT2=NT+1-I
	  IF (AM(1,NT2).LT.CV) THEN
	    IF (AM(1,NT2).NE.-999.0) THEN
              IF (AM(1,NT2-1).GE.CV) THEN
	        IX=1
	        IY=NT2-1
	        IDX=0
	        IDY=1
	        CALL TRACE(AM,NNN,MMM,IRC,IDIMEN1,X,IDIMEN2,Y,IDIMEN3)
	      END IF
	    END IF
	  END IF
	END DO
C  Now scan entire central region of array for contours
	ISS=1
	NT1=NT-1
	MT1=MT-1
	DO J=2,NT1
	  DO I=1,MT1
	    DRAW=.TRUE.
	    IF (AM(I,J).LT.CV) THEN
	      IF (AM(I,J).NE.-999.0) THEN
	        IF (AM(I+1,J).GE.CV) THEN
	          ICM=1000*(I+1)+J
	          IF (NP.NE.0) THEN
	            DO ID=1,NP
	              IF (IRC(ID).EQ.ICM) DRAW=.FALSE.
	            END DO
	          END IF
	          IF (DRAW) THEN
	            IX=I+1
	            IY=J
	            IDX=-1
	            IDY=0
	            CALL TRACE(AM,NNN,MMM,IRC,IDIMEN1,X,IDIMEN2,Y,IDIMEN3)
	          END IF
	        END IF
	      END IF
	    END IF
	  END DO
	END DO
	RETURN
	END
