	SUBROUTINE DMNMXME(X,N,XMIN,XMAX,IMIN,IMAX,MEAN)
C
C       This subroutine finds the minimum, maximum, their respective
C  indexes, and the mean from a one-dimensional array of values.
C  It is like MNMXME but for REAL*8 variable.
C				Donald H. Gudehus, September, 1984
C
	REAL*8 X(1),XMIN,XMAX,MEAN
C
	XMIN=X(1)
	XMAX=X(1)
	MEAN=X(1)
	IMIN=1
	IMAX=1
	DO I=2,N
	  IF (X(I).LT.XMIN) THEN
	    XMIN=X(I)
	    IMIN=I
	  ELSE IF (X(I).GT.XMAX) THEN
	    XMAX=X(I)
	    IMAX=I
	  END IF
	  MEAN=MEAN+X(I)
	END DO
	MEAN=MEAN/FLOAT(N)
	RETURN
	END
