	SUBROUTINE EDITCIRCL1(ARRAY,NCOL,NROW,COLUMN,ROW,MNCOLUMN,MNROW,
	1RADIUS,DELTARADIUS,VALUE)
C
C       This subroutine helps EDITCIRCL under COMMAND=F when replacing values
C  in the circle by the average of pixel values in an annulus.
C			Donald H. Gudehus, October, 1987
C			Version 2, Donald H. Gudehus, January 30, 2008
C			Converted code to Unix and FITS
C
	DIMENSION ARRAY(NCOL,NROW)
	INTEGER COLUMN,ROW,RADIUS,DELTARADIUS,DELTAHOR
C
C  Read from the map
	CALL RDFITSXY(LU_IN,IMNUM,IPNUM,ARRAY,NCOL,NROW,
	1MNCOLUMN,NCOL,MNROW,NROW)
	VALUE=0.0
	NCOUNT=0
	DO J=MIN(NROW,MAX(1,ROW-MNROW+1-RADIUS-DELTARADIUS)),
	1MAX(1,MIN(NROW,ROW-MNROW+1+RADIUS+DELTARADIUS))
	  IF (J.LE.ROW-MNROW+1) THEN
	    DELTAHOR=JINT(SQRT((RADIUS+DELTARADIUS)**2-
	1   (ROW-MNROW+1-J-0.5)**2)+0.5)
	  ELSE
	    DELTAHOR=JINT(SQRT((RADIUS+DELTARADIUS)**2-
	1   (ROW-MNROW+1-J+0.5)**2)+0.5)
	  END IF
	  DO I=MIN(NCOL,MAX(1,COLUMN-MNCOL+1-DELTAHOR)),
	1 MAX(1,MIN(NCOL,COLUMN-MNCOL+1+DELTAHOR))
	    IF (ARRAY(I,J).NE.0.0) THEN
	      VALUE=VALUE+ARRAY(I,J)
	      NCOUNT=NCOUNT+1
	    END IF
	  END DO
	END DO
C	    X=COLUMN-FLOATJ(MNCOLUMN)+1+A*COS(E)*CS-B*SIN(E)*SN
	VALUE=VALUE/NCOUNT
	RETURN
	END
