	SUBROUTINE FAKGAL2(CHOICE,CONVOLVE,ID,POSITION,INCLINA,ECCENTR,
	1PARAMETRS,SKY,ARRAYOUT,NPTS)
C
C       This subroutine helps FAKGAL when writing a galaxy's surface
C  brightness profile to a data file.
C					Donald H. Gudehus, April, 1984
C
	INCLUDE 'miipspar.for'
C
	CHARACTER*1 CHOICE
	CHARACTER*6 ID
C
	DIMENSION POSITION(2),PARAMETRS(4),ARRAYOUT(MAXDIAG)
	REAL INCLINA,INTADU,LOGINTADU
C
C  No call to FAKGALFUN is made here since it was already done in FAKGAL.
C  The values are at integer pixel locations.
	TERM=PARAMETRS(1)
	PI=3.14159265
	INTADU=1.0
	LOGINTADU=-9.999
	RADIUS=0.0
	DO I=1,NPTS
	  TERM=ARRAYOUT(I)+SKY
	  IF (RADIUS.EQ.1.0) THEN
	    INTADU=PI*TERMPREVIOUS/4+PI*TERM*2*RADIUS*
	1   SQRT(1.0-ECCENTR**2)
	    LOGINTADU=LOG10(INTADU)
	  ELSE IF (RADIUS.GT.1.0) THEN
	    INTADU=INTADU+PI*TERM*2*
	1   RADIUS*SQRT(1.0-ECCENTR**2)
	    LOGINTADU=LOG10(INTADU)
	  END IF
	  TERMPREVIOUS=TERM
	  WRITE (22,1101) ID,POSITION(1),POSITION(2),INCLINA,
	1 ECCENTR,RADIUS,TERM,LOGINTADU
1101	  FORMAT(' ',A6,1X,F9.3,1X,F9.3,1X,F7.2,6X,F6.3,1X,F7.2,1X,
	1 F13.6,1X,F11.8)
	  RADIUS=RADIUS+1.0
	END DO
	RETURN
	END
