	SUBROUTINE PRINTHEAD
C
C	This subroutine prints a FITS header on the terminal.
C			Donald H. Gudehus, January 22, 2008
C
	INCLUDE 'fitsfacts.for'
C
	CHARACTER*3 PRGFMAT
	CHARACTER*40 FILEKEYWORD
	CHARACTER*80 FILENAME,CARD,MHFITSCRD
	INTEGER PLANEKEY,STATUS
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
	CALL MESSAGE('PRINTHEAD, Version 1')
	LU_IN=11
	FILEKEYWORD='FILE='
	FILENAME=' '
	IOFL=.TRUE.
	MAPKEY=0
	PLANEKEY=1 !  The plane doesn't matter here
	NMAPS=0
	NPLNS=0
	NROWS=0
	NCOLS=0
	PRGFMAT=' '
	CALL OPENFITS(LU_IN,IOFL,FILEKEYWORD,FILENAME,MAPKEY,PLANEKEY,NMAPS,
	1NPLNS,NCOLS,NROWS,PRGFMAT,STATUS)
	CARD=' '
	NKEY=1
	NKEY_NONBLANK=1
	IF (NUMMAPS(LU_IN).GT.1) THEN
	  CALL MESSAGE('*** Primary Header ***')
	  DO WHILE(CARD.NE.'That''s all')
	    CARD=MHFITSCRD(LU_IN,0,NKEY,'That''s all')
	    CALL MESSAGE(CARD)
	    NKEY=NKEY+1
	    IF (CARD.NE.' ') NKEY_NONBLANK=NKEY_NONBLANK+1
	  END DO
	  NKEY=NKEY-1
	  NKEY_NONBLANK=NKEY_NONBLANK-1
	  WRITE (6,1040) NKEY
1040	  FORMAT(' ','There are ',I4,' keycards, including the END ',
	1 'keycard, in the primary header')
	  WRITE (7,1040) NKEY
	  WRITE (6,1041) NKEY_NONBLANK
1041	  FORMAT(' ','Of these, ',I4,' are nonblank')
	  WRITE (7,1041) NKEY_NONBLANK
	END IF
	CALL MESSAGE('*** Map Header ***')
	CARD=' '
	NKEY=1
	NKEY_NONBLANK=1
	DO WHILE(CARD.NE.'That''s all')
	  CARD=MHFITSCRD(LU_IN,IMNUM,NKEY,'That''s all')
	  CALL MESSAGE(CARD)
	  NKEY=NKEY+1
	  IF (CARD.NE.' ') NKEY_NONBLANK=NKEY_NONBLANK+1
	END DO
	NKEY=NKEY-1
	NKEY_NONBLANK=NKEY_NONBLANK-1
	WRITE (6,1045) NKEY
1045	FORMAT(' ','There are ',I4,' keycards, including the END ',
	1'keycard, in the map header')
	WRITE (7,1045) NKEY
	WRITE (6,1041) NKEY_NONBLANK
	WRITE (7,1041) NKEY_NONBLANK
	CALL CLOSEFITS(LU_IN)
C
	RETURN
	END
	
