	SUBROUTINE DATE_TIME(STRING)
C
C	This subroutine returns the date and time in character format
C				Donald H. Gudehus, Jan. 21, 2008
C
C	STRING	(R)	A character variable containing the date and time,
C			e.g., 12-Jan-2008  15:03:55
C			21 characters are used.
C	
	CHARACTER*(*) STRING
	INTEGER	MDY(3),HMS(3)	
C
	CALL IDATE(MDY)
	CALL ITIME(HMS)
C
	ENCODE(2,1002,STRING(1:2)) MDY(2)
1002	FORMAT(I2)
	IF (MDY(2).LT.10) STRING(1:1)='0'
	STRING(3:3)='-'
	IF (MDY(1).EQ.1) STRING(4:6)='Jan'
	IF (MDY(1).EQ.2) STRING(4:6)='Feb'
	IF (MDY(1).EQ.3) STRING(4:6)='Mar'
	IF (MDY(1).EQ.4) STRING(4:6)='Apr'
	IF (MDY(1).EQ.5) STRING(4:6)='May'
	IF (MDY(1).EQ.6) STRING(4:6)='Jun'
	IF (MDY(1).EQ.7) STRING(4:6)='Jul'
	IF (MDY(1).EQ.8) STRING(4:6)='Aug'
	IF (MDY(1).EQ.9) STRING(4:6)='Sep'
	IF (MDY(1).EQ.10) STRING(4:6)='Oct'
	IF (MDY(1).EQ.11) STRING(4:6)='Nov'
	IF (MDY(1).EQ.12) STRING(4:6)='Dec'
	STRING(7:7)='-'
	ENCODE(4,1004,STRING(8:11)) MDY(3)+1900
1004	FORMAT(I4)
C
	STRING(12:13)='  '
	ENCODE(2,1002,STRING(14:15)) HMS(1)
	IF (HMS(1).LT.10) STRING(14:14)='0'
	STRING(16:16)=':'
	ENCODE(2,1002,STRING(17:18)) HMS(2)
	IF (HMS(2).LT.10) STRING(17:17)='0'
	STRING(19:19)=':'
	ENCODE(2,1002,STRING(20:21)) HMS(3)
	IF (HMS(3).LT.10) STRING(20:20)='0'
C
	RETURN
	END
