	FUNCTION REALINDEX(ARRAY,N,VALUE)
C
C       This function returns the sum of the index of the array
C  ARRAY and the fractional part of a unit index such that the
C  sum corresponds to the location of VALUE.  At present it is assumed
C  that ARRAYS's values are monotonically increasing.
C  That is, ARRAY(INT)+FRAC*(ARRAY(INT+1)-ARRAY(INT))=VALUE.
C
	DIMENSION ARRAY(1)
C
	INT=1
	DIFMIN=VALUE-ARRAY(1)
	DO I=2,N
	  DIF=VALUE-ARRAY(I)
	  IF(ABS(DIF).LT.ABS(DIFMIN)) THEN
	    INT=I
	    DIFMIN=DIF
	  END IF
	END DO
C
	FRAC=DIFMIN/(ARRAY(INT+1)-ARRAY(INT))
	REALINDEX=INT+FRAC
	RETURN
	END
